---
title: Online code utilities
date: 2020-01-10T19:18:22.541Z
summary: |-
  List of helpful online code tools and utilities.
  Mirrored from github user fghber
tags:
  - tools
  - utilities
---
This has been mirrored from github - [fghber](https://github.com/fghber)'s [gist](https://gist.github.com/fghber)

# Web IDE

[ideone](https://ideone.com/) Ideone is an online compiler and debugging tool which allows youto compile source code and execute it online in more than 60 programming languages and share links to the code.
[repl.it](https://repl.it) Like ideaone, can also install missing Python packages.\
[Onlilne GDB](https://www.onlinegdb.com/) Online compiler and debugger forC, C++, Python, Java, PHP, Ruby, Perl, Pascal, Fortran, Haskell, Objective-C, Assembly, HTML, CSS, JS, SQLite, Prolog, and more.
[Coding Ground](https://www.tutorialspoint.com/codingground.htm) Advanced IDEs for C/C++, C#, GO, Java, PHP, Perl, Python, Octave/MATLOAB, R, Ruby, Scala, and compiler/interpreter for many other languages and frameworks.
[JDOODLE](https://www.jdoodle.com/) very similar to ideone but a somewhat different set of languagse/compilers.  

Dedicated: [JSFiddle](https://jsfiddle.net/) Online JavaScript, CSS, HTML or CoffeeScript code editor. Option to add various web frameworks. [.NET Fiddle](https://dotnetfiddle.net/) Online compiler for C#, VB.NET, and F# with .NET 4.5 & Roslyn 2.0. Option to install additional nuget packages.

(Cloud workspaces: https://codenvy.com/, https://codeanywhere.com/)

# RegEx

## Online Tester & Code Generator

[regex101](https:/regex101.com) Online regex tester for PHP, PCRE, JavaScript and Python that highlights pattern and matches on the fly.
https://regexr.com/ Online regex tester with gut regex replace and explain functionality.
https://www.debuggex.com/  Can show neat expression diagrams (not active anymore).
https://regexper.com/   also shows expression diagrams.
https://myregextester.com/index.php  Allows to optimize patterns (I guess this is based on this Perl's [Regexp::Optimizer](http://search.cpan.org/~dankogai/Regexp-Optimizer-0.23/lib/Regexp/Optimizer.pm)).

### Libraries

http://regexlib.com/ Regular Expression Library. Currently has 7601 expressions from 2492 contributors (most are subpar IMHO).  

### Generator

[txt2re](txt2re.com): regular expression generator (with code generator for perl php python java javascript coldfusion c c++ ruby vb vbscript j# c# c++.net vb.net)

### .NET Regex

http://regexstorm.net/tester\
http://regexhero.net/tester/\
http://www.beansoftware.com/Test-Net-Regular-Expressions/Split-String.aspx

### Java Regex

http://java-regex-tester.appspot.com/  

### Perl

http://www.regexplanet.com/advanced/perl/index.html\
http://www.regexe.com/  

### R

https://spannbaueradam.shinyapps.io/r_regex_tester/\
http://rextester.com/l/r_online_compiler  

### Ruby

http://rubular.com/

### htaccess tester

http://htaccess.mwl.be/  

### Google Analytics Regex Tester

http://www.analyticsmarket.com/freetools/regex-tester (and a general [GA RE usage guide](https://www.apasters.com/blog/regex-guide-google-analytics-tag-manager/))

### Regex Reverse Pattern generator

[sre_yield](https://github.com/google/sre_yield): generate all values that can match a given regular expression, or count possible matches efficiently\
[Xeger](https://github.com/bluezio/xeger): Java library for generating strings that match a specific regular expression.\
[PyXeger](https://github.com/bluezio/xeger): Java library for generating strings that match a specific regular expression.   

# General Languages

https://www.tutorialspoint.com/codingground.htm  

## .NET

https://dotnetfiddle.net/  

## PHP

[PHP Sandbox](http://sandbox.onlinephpfunctions.com/): Allows to test PHP code on many php versions.\
https://3v4l.org/ allows to run over 200 different PHP versions (including HHVM, etc.) in parallel - excellent for version compatibility tests\
http://c9.io An online IDE that supports many languages (free for personal use).\
http://phpfiddle.org/ A PHP online IDE with some extra resources like code search (saved, external code).  

## Python

https://www.onlinegdb.com/online_python_debugger\
[EXREX](https://github.com/asciimoo/exrex) is a command line tool and python module that generates all - or random - matching strings to a given regular expression and more.  

## Perl

http://rextester.com/l/perl_online_compiler\
https://www.jdoodle.com/execute-perl-online\
https://www.tutorialspoint.com/execute_perl_online.php  

## HTML

https://html-cleaner.com/ HTML/CSS/JS Cleaner  

## JSON:

Query test: http://www.jsonquerytool.com/#/JavaScript\
Sort array: https://aruljohn.com/jsonsort/\
Generate C# classes from JSON: http://json2csharp.com/  (Desktop tool: http://jsonclassgenerator.codeplex.com/)\
[ConvertJson.com](http://convertjson.com/) FromJson(to XML, HTML, CSV, SQL, YAML), ToJson, JsonTools (Lint, Viewer, Format, Path Analyzer)

## SQL

http://sqlfiddle.com/  (MySQL, Oracle, PosgreSQL, SQLite, MS SQL 2014)\
https://sqltest.net/   (MySQL, Oracle)\
https://sqlizer.io/

### SQL Formater

https://sqlformat.org/  (online formatting service)\
http://poorsql.com/  (Poor Man's SQL Formatter online, [download for VS, SMSS, Np++, etc.](http://architectshack.com/PoorMansTSqlFormatter.ashx#Download_4)).  

# Utilities

## Code beautifier & Syntax Highlither

https://codebeautify.org/\
https://tohtml.com/  Syntax Highlither for varius languages (useful for HTML & RTF text)

### Character Set Conversion

http://www.fileformat.info/convert/text/charset.htm

## Other

Arul's network and other technical utilities: View your IP, country, ISP name, OS, browser/UA.\
Convert IP address to hostname and vice versa, text case convert, UNIX timestamp to date, hash generator\
https://aruljohn.com/

Record and share Linux/Mac terminal sessions: https://asciinema.org/
